<?xml version="1.0" encoding="UTF-8"?>

<!--
 *
 * This help file was generated from linalg_pow.sci using help_from_sci().
 *
 -->

<refentry version="5.0-subset Scilab" xml:id="linalg_pow" xml:lang="en"
          xmlns="http://docbook.org/ns/docbook"
          xmlns:xlink="http://www.w3.org/1999/xlink"
          xmlns:svg="http://www.w3.org/2000/svg"
          xmlns:ns3="http://www.w3.org/1999/xhtml"
          xmlns:mml="http://www.w3.org/1998/Math/MathML"
          xmlns:db="http://docbook.org/ns/docbook">


  <refnamediv>
    <refname>linalg_pow</refname><refpurpose>Computes A^p</refpurpose>
  </refnamediv>



<refsynopsisdiv>
   <title>Calling Sequence</title>
   <synopsis>
   B = linalg_pow ( A , p )

   </synopsis>
</refsynopsisdiv>

<refsection>
   <title>Parameters</title>
   <variablelist>
   <varlistentry><term>A :</term>
      <listitem><para> a n-by-n matrix of doubles. May be dense, real, complex or sparse.</para></listitem></varlistentry>
   <varlistentry><term>p :</term>
      <listitem><para> a 1-by-1 matrix of doubles, integer value, positive.</para></listitem></varlistentry>
   <varlistentry><term>B :</term>
      <listitem><para> a n-by-n matrix of doubles, B=A^p</para></listitem></varlistentry>
   </variablelist>
</refsection>

<refsection>
   <title>Description</title>
   <para>
Uses a binary algorithm to compute the power of the matrix A.
This algorithm requires generally log2(p) iterations, which
is (much) faster that Scilab v5 power algorithm for real matrices.
It is based on a macro.
   </para>
   <para>
</para>
</refsection>

<refsection>
   <title>Examples</title>
   <programlisting role="example"><![CDATA[
A = [
5.    4.    3.    2.    1.
4.    4.    3.    2.    1.
0.    3.    3.    2.    1.
0.    0.    2.    2.    1.
0.    0.    0.    1.    1.
];
B = linalg_pow(A,5)
E = [
37721.    47455.    45750.    34540.    18160.
33940.    42751.    41245.    31150.    16380.
15420.    19695.    19156.    14525.    7650.
3720.     5010.     5020.     3861.     2045.
360.      570.      620.      495.      266.
];

// With a complex matrix
A = (3  - 2 * %i ) * testmatrix("frk",5)
A^6
linalg_pow(A,6)

// Measure the difference between Scilab's pow and this pow
p = 99999;
tic();A^p;toc() // Typically: 2.7 s
tic();linalg_pow(A,p);toc() // Typically: 0.003 s
tic();linalg_powfast(A,p);toc() // Typically: 0.002 s

   ]]></programlisting>
</refsection>

<refsection>
   <title>Authors</title>
   <simplelist type="vert">
   <member>Copyright (C) 2009 - Vladimir Sergievskiy</member>
   <member>Copyright (C) 2010 - 2011 - DIGITEO - Michael Baudin</member>
   </simplelist>
</refsection>

<refsection>
   <title>Bibliography</title>
   <para>D. Knuth, "The Art of Computer Programming", Vol. 2, "Seminumerical Algorithms"</para>
   <para>http://bugzilla.scilab.org/show_bug.cgi?id=8428</para>
</refsection>
</refentry>
